<html>
<head>
<title>OgreGLRenderTexture.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_5bc5f2f46c6364f2594540d45df3d051.html">GL</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7b8a29f58b064e3a63f570f2fc89729.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGLRenderTexture.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGLRenderTexture_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __GLRENDERTEXTURE_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __GLRENDERTEXTURE_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLTexture_8h.html">OgreGLTexture.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre {
<a name="l00037"></a><a class="code" href="structOgre_1_1GLSurfaceDesc.html">00037</a>     <span class="keyword">struct </span><a class="code" href="OgrePlatform_8h.html#af4c2f5df97e3050dd5266408be42db4b">_OgrePrivate</a> <a class="code" href="structOgre_1_1GLSurfaceDesc.html" title="GL surface descriptor.">GLSurfaceDesc</a>
<a name="l00038"></a>00038     {
<a name="l00039"></a>00039     <span class="keyword">public</span>:
<a name="l00040"></a><a class="code" href="structOgre_1_1GLSurfaceDesc.html#a9c8b7fc7ce22ded53d03c7838476befa">00040</a>         <a class="code" href="classOgre_1_1GLHardwarePixelBuffer.html">GLHardwarePixelBuffer</a> *<a class="code" href="structOgre_1_1GLSurfaceDesc.html#a9c8b7fc7ce22ded53d03c7838476befa">buffer</a>;
<a name="l00041"></a><a class="code" href="structOgre_1_1GLSurfaceDesc.html#ad8871731ec9027a7dd6eabee59786431">00041</a>         <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1GLSurfaceDesc.html#ad8871731ec9027a7dd6eabee59786431">zoffset</a>;
<a name="l00042"></a><a class="code" href="structOgre_1_1GLSurfaceDesc.html#a06710eae3716931ee6b6e2a796757177">00042</a>         <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> <a class="code" href="structOgre_1_1GLSurfaceDesc.html#a06710eae3716931ee6b6e2a796757177">numSamples</a>;
<a name="l00043"></a>00043 
<a name="l00044"></a><a class="code" href="structOgre_1_1GLSurfaceDesc.html#a17db8cb3634f2023f2f7cb7f92cd4389">00044</a>         <a class="code" href="structOgre_1_1GLSurfaceDesc.html#a17db8cb3634f2023f2f7cb7f92cd4389">GLSurfaceDesc</a>() :buffer(0), zoffset(0), numSamples(0) {}
<a name="l00045"></a>00045     };
<a name="l00046"></a>00046     
<a name="l00049"></a><a class="code" href="classOgre_1_1GLRenderTexture.html">00049</a>     <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1GLRenderTexture.html" title="Base class for GL Render Textures.">GLRenderTexture</a>: <span class="keyword">public</span> <a class="code" href="classOgre_1_1RenderTexture.html" title="This class represents a RenderTarget that renders to a Texture.">RenderTexture</a>
<a name="l00050"></a>00050     {
<a name="l00051"></a>00051     <span class="keyword">public</span>:
<a name="l00052"></a>00052         <a class="code" href="classOgre_1_1GLRenderTexture.html" title="Base class for GL Render Textures.">GLRenderTexture</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <span class="keyword">const</span> <a class="code" href="structOgre_1_1GLSurfaceDesc.html" title="GL surface descriptor.">GLSurfaceDesc</a> &amp;target, <span class="keywordtype">bool</span> writeGamma, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> fsaa);
<a name="l00053"></a>00053         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1GLRenderTexture.html" title="Base class for GL Render Textures.">GLRenderTexture</a>();
<a name="l00054"></a>00054         
<a name="l00055"></a><a class="code" href="classOgre_1_1GLRenderTexture.html#a477c9f9b3e986e9cf7f3346443623492">00055</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GLRenderTexture.html#a477c9f9b3e986e9cf7f3346443623492">requiresTextureFlipping</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00056"></a>00056 
<a name="l00057"></a><a class="code" href="classOgre_1_1GLRenderTexture.html#a0c1183426657f0c4bb9cab4d0849e6cd">00057</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1GLRenderTexture.html#a0c1183426657f0c4bb9cab4d0849e6cd">CustomAttributeString_FBO</a>;
<a name="l00058"></a><a class="code" href="classOgre_1_1GLRenderTexture.html#ac7682594cac556e4830cf1d1f3201726">00058</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1GLRenderTexture.html#ac7682594cac556e4830cf1d1f3201726">CustomAttributeString_TARGET</a>;
<a name="l00059"></a><a class="code" href="classOgre_1_1GLRenderTexture.html#a71d9d9ecb01f76de433f3b3b1fd3b8ce">00059</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1GLRenderTexture.html#a71d9d9ecb01f76de433f3b3b1fd3b8ce">CustomAttributeString_GLCONTEXT</a>;
<a name="l00060"></a>00060     };
<a name="l00061"></a>00061     
<a name="l00064"></a><a class="code" href="classOgre_1_1GLRTTManager.html">00064</a>     <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1GLRTTManager.html" title="Manager/factory for RenderTextures.">GLRTTManager</a>: <span class="keyword">public</span> <a class="code" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a>&lt;GLRTTManager&gt;
<a name="l00065"></a>00065     {
<a name="l00066"></a>00066     <span class="keyword">public</span>:
<a name="l00067"></a>00067         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1GLRTTManager.html" title="Manager/factory for RenderTextures.">GLRTTManager</a>();
<a name="l00068"></a>00068         
<a name="l00071"></a>00071         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RenderTexture.html" title="This class represents a RenderTarget that renders to a Texture.">RenderTexture</a> *createRenderTexture(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <span class="keyword">const</span> <a class="code" href="structOgre_1_1GLSurfaceDesc.html" title="GL surface descriptor.">GLSurfaceDesc</a> &amp;target, <span class="keywordtype">bool</span> writeGamma, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> fsaa) = 0;
<a name="l00072"></a>00072         
<a name="l00075"></a>00075         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> checkFormat(<a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> format) = 0;
<a name="l00076"></a>00076         
<a name="l00079"></a>00079         <span class="keyword">virtual</span> <span class="keywordtype">void</span> bind(<a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> *target) = 0;
<a name="l00080"></a>00080         
<a name="l00085"></a>00085         <span class="keyword">virtual</span> <span class="keywordtype">void</span> unbind(<a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> *target) = 0;
<a name="l00086"></a>00086 
<a name="l00087"></a><a class="code" href="classOgre_1_1GLRTTManager.html#a9009ddc7bebd9a077c2152e9432ff634">00087</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getBestDepthStencil(GLenum internalFormat, GLenum *depthFormat, GLenum *stencilFormat)
<a name="l00088"></a>00088         {
<a name="l00089"></a>00089             *depthFormat = <a class="code" href="OgreGLESPrerequisites_8h.html#a089a3736e5280b9c7cc50129e2659974">GL_NONE</a>;
<a name="l00090"></a>00090             *stencilFormat = <a class="code" href="OgreGLESPrerequisites_8h.html#a089a3736e5280b9c7cc50129e2659974">GL_NONE</a>;
<a name="l00091"></a>00091         }
<a name="l00092"></a>00092 
<a name="l00095"></a>00095         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MultiRenderTarget.html" title="This class represents a render target that renders to multiple RenderTextures at once.">MultiRenderTarget</a>* createMultiRenderTarget(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp; name);
<a name="l00096"></a>00096         
<a name="l00099"></a>00099         <span class="keyword">virtual</span> <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> getSupportedAlternative(<a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> format);
<a name="l00100"></a>00100     };
<a name="l00101"></a>00101     
<a name="l00104"></a>00104     <span class="keyword">class </span>GLCopyingRTTManager;
<a name="l00105"></a><a class="code" href="classOgre_1_1GLCopyingRenderTexture.html">00105</a>     <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1GLCopyingRenderTexture.html">GLCopyingRenderTexture</a>: <span class="keyword">public</span> <a class="code" href="classOgre_1_1GLRenderTexture.html" title="Base class for GL Render Textures.">GLRenderTexture</a>
<a name="l00106"></a>00106     {
<a name="l00107"></a>00107     <span class="keyword">public</span>:
<a name="l00108"></a>00108         <a class="code" href="classOgre_1_1GLCopyingRenderTexture.html">GLCopyingRenderTexture</a>(<a class="code" href="classOgre_1_1GLCopyingRTTManager.html" title="Simple, copying manager/factory for RenderTextures.">GLCopyingRTTManager</a> *manager, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <span class="keyword">const</span> <a class="code" href="structOgre_1_1GLSurfaceDesc.html" title="GL surface descriptor.">GLSurfaceDesc</a> &amp;target, 
<a name="l00109"></a>00109             <span class="keywordtype">bool</span> writeGamma, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> fsaa);
<a name="l00110"></a>00110         
<a name="l00111"></a>00111         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getCustomAttribute(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">void</span>* pData);
<a name="l00112"></a>00112     };
<a name="l00113"></a>00113     
<a name="l00117"></a><a class="code" href="classOgre_1_1GLCopyingRTTManager.html">00117</a>     <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1GLCopyingRTTManager.html" title="Simple, copying manager/factory for RenderTextures.">GLCopyingRTTManager</a>: <span class="keyword">public</span> <a class="code" href="classOgre_1_1GLRTTManager.html" title="Manager/factory for RenderTextures.">GLRTTManager</a>
<a name="l00118"></a>00118     {
<a name="l00119"></a>00119     <span class="keyword">public</span>:
<a name="l00120"></a>00120         <a class="code" href="classOgre_1_1GLCopyingRTTManager.html" title="Simple, copying manager/factory for RenderTextures.">GLCopyingRTTManager</a>();
<a name="l00121"></a>00121         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1GLCopyingRTTManager.html" title="Simple, copying manager/factory for RenderTextures.">GLCopyingRTTManager</a>();
<a name="l00122"></a>00122         
<a name="l00125"></a>00125         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RenderTexture.html" title="This class represents a RenderTarget that renders to a Texture.">RenderTexture</a> *createRenderTexture(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <span class="keyword">const</span> <a class="code" href="structOgre_1_1GLSurfaceDesc.html" title="GL surface descriptor.">GLSurfaceDesc</a> &amp;target, <span class="keywordtype">bool</span> writeGamma, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> fsaa);
<a name="l00126"></a>00126         
<a name="l00129"></a>00129         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> checkFormat(<a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> format);
<a name="l00130"></a>00130         
<a name="l00133"></a>00133         <span class="keyword">virtual</span> <span class="keywordtype">void</span> bind(<a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> *target);
<a name="l00134"></a>00134         
<a name="l00137"></a>00137         <span class="keyword">virtual</span> <span class="keywordtype">void</span> unbind(<a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> *target);
<a name="l00138"></a>00138     };
<a name="l00139"></a>00139 }
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 <span class="preprocessor">#endif // __GLTEXTURE_H__</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
